Package org.eclipse.lemminx.services.extensions

## Interface ISymbolsProviderParticipant

All Known Implementing Classes:
  `ContentModelSymbolsProviderParticipant`

    public interface ISymbolsProviderParticipant

Symbols provider participant API.

### Nested Class Summary

Nested Classes
`static class` `ISymbolsProviderParticipant.SymbolStrategy`

### Method Summary

All Methods Instance Methods Abstract Methods

`ISymbolsProviderParticipant.SymbolStrategy`

`applyFor​(DOMDocument document)`

Returns the symbol strategy to apply for the given DOM document : `ISymbolsProviderParticipant.SymbolStrategy.UNADAPTABLE` : means that the participant is not applicable for the document `ISymbolsProviderParticipant.SymbolStrategy.INSERT` : means that the participant will insert symbols on the top of the standards symbols.

`void` `findDocumentSymbols​(DOMDocument document, DocumentSymbolsResult symbols, XMLSymbolFilter filter, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Fill the given document symbol result with custom document symbol.
`void` `findSymbolInformations​(DOMDocument document, SymbolInformationResult symbols, XMLSymbolFilter filter, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Fill the given symbol information result with custom symbol informations.

### Method Detail

#### applyFor

    ISymbolsProviderParticipant.SymbolStrategy applyFor​(DOMDocument document)

Returns the symbol strategy to apply for the given DOM document :

- `ISymbolsProviderParticipant.SymbolStrategy.UNADAPTABLE` : means that the participant is not applicable for the document
- `ISymbolsProviderParticipant.SymbolStrategy.INSERT` : means that the participant will insert symbols on the top of the standards symbols. *
- `ISymbolsProviderParticipant.SymbolStrategy.REPLACE` : means that the participant will replace the standard XML symbols with their own symbols.

Parameters:
  `document` - the DOM document.
Returns:
  the symbol strategy to apply for the given DOM document.

#### findSymbolInformations

    void findSymbolInformations​(DOMDocument document,
                                SymbolInformationResult symbols,
                                XMLSymbolFilter filter,
                                org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)

Fill the given symbol information result with custom symbol informations.

Parameters:
  `document` - the DOM document.
  `symbols` - the symbols to update.
  `filter` - the symbol filter.
  `cancelChecker` - the cancel checker.

#### findDocumentSymbols

    void findDocumentSymbols​(DOMDocument document,
                             DocumentSymbolsResult symbols,
                             XMLSymbolFilter filter,
                             org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)

Fill the given document symbol result with custom document symbol.

Parameters:
  `document` - the DOM document.
  `symbols` - the symbols to update.
  `filter` - the symbol filter.
  `cancelChecker` - the cancel checker.